import 'package:panda/models/form-descriptor.model.dart';
import 'package:panda/models/form-result.model.dart';
import 'package:panda/models/form-validation.model.dart';
import 'package:nice_flutter_kit/nice_flutter_kit.dart';

class PandaState extends NiceBaseState {
  final bool submitted;
  final PandaFormDescriptorModel? formDescriptor;
  final PandaFormResultModel? formResult;
  final PandaFormValidation? formValidation;

  const PandaState({
    required super.loading,
    required super.error,
    required this.submitted,
    required this.formDescriptor,
    required this.formResult,
    required this.formValidation,
  });

  const PandaState.initialState()
      : submitted = false,
        formDescriptor = null,
        formResult = null,
        formValidation = null,
        super.initialState();

  PandaState copyWith({
    bool? loading,
    bool? error,
    bool? submitted,
    PandaFormDescriptorModel? formDescriptor,
    PandaFormResultModel? formResult,
    PandaFormValidation? formValidation,
  }) {
    return PandaState(
      loading: loading ?? this.loading,
      error: error ?? false,
      submitted: submitted ?? this.submitted,
      formDescriptor: formDescriptor ?? this.formDescriptor,
      formResult: formResult ?? this.formResult,
      formValidation: formValidation ?? this.formValidation,
    );
  }

  @override
  NiceBaseState copyWithLoadingAndError({bool? loading, bool? error}) {
    return copyWith(loading: loading, error: error);
  }

  @override
  List<Object?> get props => [loading, error, submitted, formDescriptor, formResult, formValidation];
}
