// ignore_for_file: constant_identifier_names

class PandaValidatorTypeEnum {
  final String _value;

  const PandaValidatorTypeEnum._internal(this._value);

  factory PandaValidatorTypeEnum.fromString(String? data) {
    for (final value in values) {
      if (data == value._value) {
        return value;
      }
    }

    return Unknown;
  }

  // ignore: annotate_overrides
  String toString() => _value;

  static const Unknown = PandaValidatorTypeEnum._internal("unknown");
  static const MaxLength = PandaValidatorTypeEnum._internal("max_length");
  static const MinLength = PandaValidatorTypeEnum._internal("min_length");
  static const Required = PandaValidatorTypeEnum._internal("required");
  static const RequiredIf = PandaValidatorTypeEnum._internal("required_if");
  static const Range = PandaValidatorTypeEnum._internal("range");

  static const values = [Unknown, MaxLength, MinLength, Required, RequiredIf, Range];
}
