import 'dart:collection';

import 'package:panda/models/view-config-types/type-config.model.dart';

class PandaDropdownTypeConfigModel implements PandaTypeConfigModel {
  late final List<PandaDropdownTypeConfigOptionModel> options;

  PandaDropdownTypeConfigModel({
    required this.options,
  });

  PandaDropdownTypeConfigModel.fromJson(LinkedHashMap<String, dynamic>? json) {
    if (json == null) {
      return;
    }

    options = List.from(json["options"]).map((optionJson) {
      return PandaDropdownTypeConfigOptionModel.fromJson(optionJson);
    }).toList();
  }

  @override
  Map<String, dynamic> toJson() {
    return {
      "options": options.map((option) => option.toJson()).toList(),
    };
  }
}

class PandaDropdownTypeConfigOptionModel {
  late final int value;
  late final String text;
  late final String? description;

  PandaDropdownTypeConfigOptionModel({
    required this.value,
    required this.text,
    this.description,
  });

  PandaDropdownTypeConfigOptionModel.fromJson(LinkedHashMap<String, dynamic>? json) {
    if (json == null) return;

    value = json["value"];
    text = json["text"];
    description = json["description"];
  }

  Map<String, dynamic> toJson() {
    return {
      "value": value,
      "text": text,
      "description": description,
    };
  }
}
