import 'dart:collection';

import 'package:panda/models/view-config-types/type-config.model.dart';

class PandaShortTextTypeConfigModel implements PandaTypeConfigModel {
  late final bool? showMask;
  late final String? mask;

  PandaShortTextTypeConfigModel({
    this.showMask: false,
    this.mask,
  });

  PandaShortTextTypeConfigModel.fromJson(LinkedHashMap<String, dynamic>? json) {
    if (json == null) {
      return;
    }

    showMask = json["showMask"] == "true";
    mask = json["mask"];
  }

  @override
  Map<String, dynamic> toJson() {
    return {
      "showMask": showMask,
      "mask": mask,
    };
  }
}
